unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, MathEdit, Unit_LGS;

type
  TForm1 = class(TForm)
    IntEdit1: TIntEdit;
    IntEdit2: TIntEdit;
    Label1: TLabel;
    Label2: TLabel;
    StringGrid1: TStringGrid;
    BtnManipulate: TButton;
    BtnRedim: TButton;
    BtnSendData: TButton;
    BtnReceiveData: TButton;
    procedure BtnManipulateClick(Sender: TObject);
    procedure BtnRedimClick(Sender: TObject);
    procedure BtnSendDataClick(Sender: TObject);
    procedure BtnReceiveDataClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.BtnRedimClick(Sender: TObject);
  var i : Integer;
  begin
  EquaCount := IntEdit1.Value;    // Hier wird festgelegt, welcher Teil des
  VarCount  := IntEdit2.Value;    //    Koeffizientenarrays aktiv ist.
  StringGrid1.RowCount := EquaCount + 1;
  StringGrid1.ColCount := VarCount  + 2;
  For i := 1 to EquaCount do      // Gleichungen durchnummerieren
    StringGrid1.Cells[0, i] := IntToStr(i) + '. Gleichung';
  For i := 1 to VarCount do       // Variablen durchnummerieren
    StringGrid1.Cells[i, 0] := 'x' + IntToStr(i);
  StringGrid1.Cells[VarCount + 1, 0] := '  = ';     // Kosmetik!
  StringGrid1.Repaint;            // Neu zeichnen!
  end;

procedure TForm1.BtnSendDataClick(Sender: TObject);
  var gl   : TEquation;
      i, k : Integer;
  begin
  For i := 1 to EquaCount do begin
    For k := 1 to VarCount do
      gl[k] := StrToFloat(StringGrid1.Cells[k, i]);
    gl[0] := StrToFloat(StringGrid1.Cells[VarCount + 1, i]);
    SetEquation(i, gl);           // Eigentliche Datenbergabe
    end;
  BtnManipulate.Enabled := True;
  end;

procedure TForm1.BtnManipulateClick(Sender: TObject);
  begin
  Manipulate;
  end;

procedure TForm1.BtnReceiveDataClick(Sender: TObject);
  var gl   : TEquation;
      i, k : Integer;
  begin
  For i := 1 to EquaCount do begin
    GetEquation(i, gl);
    For k := 1 to VarCount do
       StringGrid1.Cells[k, i] := FloatToStr(gl[k]);
    StringGrid1.Cells[Varcount + 1, i] := FloatToStr(gl[0]);
    end;
  end;

procedure TForm1.FormCreate(Sender: TObject);
  { Initialisierung des StringGrid mit Test-Daten eines 3x3-Systems;
    ist hier ntig, weil der Inhalt eines Delphi-StringGrid nicht zur
    Programmierzeit gesetzt werden kann.    L = ( 3, 2, -1 )  }
  begin
  IntEdit1.Value := 3;
  IntEdit2.Value := 3;
  BtnRedimClick(Sender);      // Dimensionierung und Beschriftung
  With StringGrid1 do begin   // Beipiel-Daten eines LGS laden
    Cells[1,1] := ' 3'; Cells[2,1] := '-2'; Cells[3,1] := '-1'; Cells[4,1] := ' 6';
    Cells[1,2] := ' 2'; Cells[2,2] := ' 1'; Cells[3,2] := ' 3'; Cells[4,2] := ' 5';
    Cells[1,3] := '-4'; Cells[2,3] := ' 4'; Cells[3,3] := '-8'; Cells[4,3] := ' 4';
    end;
  end;

end.
